/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _AIOROS_H_
#define _AIOROS_H_

/*
 *  resolve ambiguity with
 *  ansi C exit function
 *  that cause EIP resetting
 *  by the compiler.
 *  (if anyone knows how to instruct
 *   gcc in order to avoid that, please
 *    let me know)
 */
#define exit do_exit

/* C System Calls wrapper */

int
write(int fd, const void *buffer, int len);

int
read(int fd, const void *buffer, int len);

int
create_process(const char *path, const char *arg0, ...);

int
do_exit(int);

int
wait(int pid);

#endif
