/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include <aiorOS.h>
#include <stdio.h>

#define MAJOR 0
#define MINOR 2 
#define REVISION 0

void process_command(char *line);

/*
 * Main is at 0x0.
 *
 * Dereferencing a NULL pointer will
 * not cause any memory exception!
 *
 */
int main(int argc, char *argv[])
{
   char line[80];
   int pid;

   printf("aiorOS  -  Multitasking 32bit Operating System  [Version %d.%d.%d]\n"
           "Copyright (C) 2005 Salvatore Iengo <salvatoreiengo@hotmail.com>\n\n",
           MAJOR,MINOR,REVISION);

   printf("Type 'help' for details.\n\n");

   for(;;){
      /*
     * prompt shell
     */
      printf("shell>");
      /*
     * get & process command
     */
      process_command(gets(line));
   }

   exit(0);
}

void show_help(void){

   printf("\nAvailable programs:\n\t'echo.bin',\n\t'shell.bin'\n\t'test.bin'\nAvailable commands:\n\t'exit'\n\t'test'\n\n");

}


extern char* strstr(const char *source, const char *need);

/*
 * Basic & minimal command line processing
 * TODO: define a more complex grammar
 */
void process_command(char *line){
   if(line && *line){
      int pid;
      char *args = NULL;

      /* skipping spaces */
      while((*line)==' ')line++;
      if((args = strstr(line," "))){
         /* terminating command string */
         *args++ = 0;
         /* skipping spaces */
         while((*args)==' ')args++;
      }

      if(strcmp(line,"help")==0){
          show_help();
      }
      else if(strcmp(line,"exit")==0){
         /*
        * Exit returns on last process
        */
         exit(0);
         printf("Cannot abort main shell process\n");
      }
      else if(strcmp(line,"test")==0){
         int pid[5], i,j;
         char arg[80];

         /* multitasking example */

         /* launch 5 processes */
         for(i=0;i<5;i++){
            sprintf(arg,"proc%d",i);
            pid[i] = create_process("test.bin", arg,NULL);
            for(j=0;j<0xFFF;j++); /* delay */
         }
         /* wait for all of them*/
         for(i=0;i<5;i++)
            wait(pid[i]);
      }
      else if((pid = create_process(line, args,NULL))>=0)
      {
         /*
        * wait for completion
        */
         wait(pid);
      }
      else
      {
         /*
        * process not created
        */
         printf("shell: %s: command not found\n",line);
      }
   }
}
