/*

This file is part of maketab

maketab - extract array identifier from a file
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/


#include <stdio.h>
#include <string.h>
#include "yacc.y.h"

char buffer[80];
char *curr_identifier=buffer;

void onNewIdentifier(void);

extern FILE *yyin;
FILE* fout;

int main(int argc, char *argv[]){
   yyin = (argc>1) ? fopen(argv[1],"r") : stdin;
   fout = (argc>2) ? fopen(argv[2],"w") : stdout;

   fprintf(fout,"struct\n"
           "{\n"
              "\tchar name[64];\n"
              "\tunsigned char* data;\n"
              "\tunsigned int size;\n"
           "}\n"
           "bin_table[]={\n");

   yyparse();

   fprintf(fout,"\t{0,0,0}\n};\n");

   fclose(yyin);
}

void onNewIdentifier(void){
   char name[64];
   int i;

   strcpy(name,curr_identifier);
   for(i=0;i<strlen(name);i++)
      if(name[i]=='_') name[i]='.';

   fprintf(fout,"\t{\"%s\",(unsigned char*)&%s,sizeof(%s)},\n",
                name,curr_identifier,curr_identifier);
}
