/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _FS_H_
#define _FS_H_

#include <types.h>

/*
   NOTE:
   do not rely on the contents
   of this structure: them will
   change in the future when
   real file-system will be
   provided.
*/
typedef struct{
   char *offset;
   char *base;
   int size;
}file_t;

#define FILE_SIZE(f) f.size

file_t fs_open(char *path);
int fs_read(file_t *file, char *buffer, int size);
int fs_close(file_t *file);
int fs_seek(file_t *file, int offset);
int fs_exists(char *path, int *size);

#endif
