/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _IDT_H_
#define _IDT_H_

#include<types.h>

#define IDT_SIZE 49 /* 17INT/EXC + 15UNUSED + 16IRQ + 1SYSCALL */
#define TASK_GATE   0x1
#define INTERR_GATE 0x2 
#define TRAP_GATE 0x3

struct IDTgate_t{
   word OffsetL;
   word Selector;
      struct{
         byte Reserved0;
         dword Reserved1:2;
         dword Reserved2:1;
         dword SizeD:1;
         dword Reserved3:1;
         dword DPL:2;
         dword Present:1;
      }__attribute__((packed)) Options;
   word OffsetH;
};


void initIDT(void);
struct IDTgate_t makeIDTgate(void (*func)(void), int DPL, word type);
void exceptionHandler(dword num, dword code);

extern struct IDTgate_t *IDTgates;
extern void(*INTtable[])(void);

extern void ISR_NULL(void);
extern void ISR_0(void);
extern void ISR_1(void);
extern void ISR_2(void);
extern void ISR_3(void);
extern void ISR_4(void);
extern void ISR_5(void);
extern void ISR_6(void);
extern void ISR_7(void);
extern void ISR_8(void);
extern void ISR_9(void);
extern void ISR_10(void);
extern void ISR_11(void);
extern void ISR_12(void);
extern void ISR_13(void);
extern void ISR_14(void);
extern void ISR_15(void);
extern void ISR_16(void);
extern void ISR_17(void);
extern void ISR_32(void);
extern void ISR_33(void);
extern void ISR_34(void);
extern void ISR_35(void);
extern void ISR_36(void);
extern void ISR_37(void);
extern void ISR_38(void);
extern void ISR_39(void);
extern void ISR_40(void);
extern void ISR_41(void);
extern void ISR_42(void);
extern void ISR_43(void);
extern void ISR_44(void);
extern void ISR_45(void);
extern void ISR_46(void);
extern void ISR_47(void);
extern void SYSCALL_ISR(void);

#endif
