/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _KEYBOARD_H_
#define _KEYBOARD_H_

#include <idt.h>
#include <irq.h>
#include <io.h>
#include <vga.h>
#include <kernel.h>
#include <types.h>

#define IS_KEYPRESS(key) (!(key&0x80))

/* bit position */
#define SHIFT    0
#define CTRL     1
#define ALT      2
#define CAPS     3

void initKeyboard();
void (*keybSignal(void (*f)(byte)))(byte);

#endif
