/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _QUEUE_H_
#define _QUEUE_H_

#define MAX_QUEUE 256

#define countOnQueue(q) (q.count)
#define headOnQueue(q) ((q.count>0)? q.mem[q.head] : -1)
#define tailOnQueue(q) ((q.count>0)? q.mem[q.tail] : -1)

typedef struct{
   char mem[MAX_QUEUE];
   int volatile head;
   int volatile tail;
   int volatile count;
}queue_t;

void initQueue(queue_t *q);
void enqueue(queue_t *q, char c);
char dequeue(queue_t *q); 
char enqueueUndo(queue_t *q);

#endif
