/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _SWAPPER_H_
#define _SWAPPER_H_

#include <kernel.h>
#include <mem.h>
#include <task.h>

/* swap out shared page */
int swap_out_shared(dword address, void *page);
/* swap in shared page */
int swap_in_shared(dword address, void *buffer);
/* swap out singe page */
int swap_out(int owner, dword address, void *page);
/* swap in single page*/
int swap_in(int owner, dword address, void *buffer);
/* do swap at least n pages
   out of memory */
int swapper(int n);

#endif
