/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _VGA_H_
#define _VGA_H_

#include <std/string.h>

#include <types.h>
#include <io.h>

/*character based*/
#define SCREEN_HEIGHT 25
#define SCREEN_WIDTH  80

/*
#define VIDEO_CELL(ch , col) ({\
      video_cell_t cell;\
      cell.character = ch;\
      cell.color = col;\
      cell;\
     })

#define VIDEO_CELL_NULL VIDEO_CELL(SPACE,WHITE)
*/

enum Colors {BLACK, BLUE, GREEN, CYAN, RED, MAGENTA, BROWN, WHITE,
      DARK_GRAY, BRIGHT_BLUE, BRIGHT_GREEN, BRIGHT_CYAN, BRIGHT_RED,
      BRIGHT_MAGENTA, YELLOW, BRIGHT_WHITE};

/*
typedef struct {unsigned char character; unsigned char color;} video_cell_t;
typedef struct {video_cell_t mem[SCREEN_WIDTH];} *video_row_t;
typedef struct {video_cell_t mem[SCREEN_HEIGHT][SCREEN_WIDTH];} *video_t;
*/

void initVGA(void);
/*origin top left*/
void putChar(int x, int y, char ch);
void moveCursor(int x, int y);
void scrollUp(void);
void clearScreen(void);

/*
  that allow you to write something like:
  
  VGA[y][x].color = RED;
  VGA[y][x].character = 'a';
  
  or
  
  VGA[y][x] = VIDEO_EMPTY_CELL;
  
  REMEMBER that video addressing works in the following way:
  
  0             x
0 +------------->
  |
  |
  |
 y|
  v
  
  You must specify Y axis as first: VGA[y][x]
*/

#endif
