/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include <io.h>

/* outports a byte */
void outport(unsigned short port, unsigned char val){
   __asm__ __volatile__ ("outb %0,%1"::"a"(val), "Nd" (port));
}

/* inports a byte */
unsigned char inport(unsigned short port){
   unsigned char ret;
   __asm__ __volatile__ ("inb %1,%0":"=a"(ret):"Nd"(port));
   return ret;
}

/* waits for IO to complete*/
void port_wait(void){
   __asm__ __volatile__ ("jmp 1f; 1: jmp 1f;1:");
}

/* outports and wait */
void outport_wait(unsigned short port, unsigned char val){
   outport(port, val);
   port_wait();
}

/* inports and wait */
unsigned char inport_wait(unsigned short port){
   unsigned char ret;
   ret = inport(port);
   port_wait();
   return ret;
}

