/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include <vga.h>

#define SPACE ((char)32)
#define VGA_BASE (word*)0xB8000
#define CELL_SIZE sizeof(word)
#define CELL(ch, col) ((((word)col)<<8)+ch)

static word *vga = VGA_BASE;

static void setOriginCursor(void);

void initVGA(void){
   setOriginCursor();
}

void putChar(int x, int y, char ch){
   if(x<SCREEN_WIDTH && y<SCREEN_HEIGHT){
      vga[(SCREEN_WIDTH*y)+x] = CELL(ch, WHITE);
   }
}

void moveCursor(int x, int y){
   int value;
   value = (y*SCREEN_WIDTH+x);
   outport_wait(0x3D4, 14);
   outport_wait(0x3D5, value>>8);
   outport_wait(0x3D4, 15);
   outport_wait(0x3D5, value); 
}

static void setOriginCursor(void) {
    outport_wait(0x3D4, 12);
    outport_wait(0x3D5, 0);
    outport_wait(0x3D4, 13);
    outport_wait(0x3D5, 0);
}

void scrollUp(void){
   int i;
   memmove((void*)VGA_BASE, (void*)(VGA_BASE+SCREEN_WIDTH), SCREEN_WIDTH * (SCREEN_HEIGHT-1) * CELL_SIZE);
   for(i=0;i<SCREEN_WIDTH;i++) vga[(SCREEN_WIDTH*(SCREEN_HEIGHT-1))+i]=CELL(32,WHITE);
}

void clearScreen(void){
   int i;
   for(i=0;i<SCREEN_WIDTH*SCREEN_HEIGHT;i++) vga[i]=CELL(32,WHITE);
   /*memset(VGA_BASE, 0, SCREEN_WIDTH * SCREEN_HEIGHT * CELL_SIZE);*/
   moveCursor(0,0);
}

/*video_cell_t VIDEO_CELL(char ch, enum Colors col){
      video_cell_t cell;
      cell.character = ch;
      cell.color = col;
      return cell;
     }
*/
