/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include <kernel.h>
#include <irq.h>
#include <timer.h>
#include <idt.h>
#include <gdt.h>
#include <mem.h>
#include <task.h>
#include <scheduler.h>
#include <termio.h>
#include <fs.h>


int main(void);
/*
  kernel
  entry point
*/
void _start(void)
{
   for(;;)
      main();
}

int main(void)
{
   initGDT();
   initIDT();
   initIRQ();
   initTTIO();
   initTimer();
   initMem();
   initTasks();

   {
      int pid = tsk_create_process("shell.bin",0,NULL);

      if(!(pid<0))
         contextSwitch();
   }

   kprintf("Cannot start shell process...halting system!");
   for(;;);

  return 0;
}
